# coding: utf-8

"""
    Form Service API

    A list of form and Xaas APIs.  This page describes the RESTful APIs for Form Service. The APIs facilitate CRUD operations on the various resources and entities used throughout Form service (Custom Resource , Form Definition etc.) and allow operations on them (creating custom resource type , fetch form status etc.).  Some of the APIs that list collections of resources also support OData like implementation. Below query params can be used across Form and XaaS entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/form-service/api/custom/resource-types?$orderby=name%20DESC```  2. `page`, `size` - page used in conjunction with `size` helps in pagination of resources.      ```/form-service/api/custom/resource-types?page=0&size=20```   # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class FormserviceapiformsrendererexternalvaluesFieldType(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'data_type': 'str',
        'reference_type': 'str',
        'fields': 'list[FormserviceapiformsrendererexternalvaluesFieldTypeFields]',
        'is_multiple': 'bool'
    }

    attribute_map = {
        'data_type': 'dataType',
        'reference_type': 'referenceType',
        'fields': 'fields',
        'is_multiple': 'isMultiple'
    }

    def __init__(self, data_type=None, reference_type=None, fields=None, is_multiple=None):  # noqa: E501
        """FormserviceapiformsrendererexternalvaluesFieldType - a model defined in Swagger"""  # noqa: E501
        self._data_type = None
        self._reference_type = None
        self._fields = None
        self._is_multiple = None
        self.discriminator = None
        if data_type is not None:
            self.data_type = data_type
        if reference_type is not None:
            self.reference_type = reference_type
        if fields is not None:
            self.fields = fields
        if is_multiple is not None:
            self.is_multiple = is_multiple

    @property
    def data_type(self):
        """Gets the data_type of this FormserviceapiformsrendererexternalvaluesFieldType.  # noqa: E501


        :return: The data_type of this FormserviceapiformsrendererexternalvaluesFieldType.  # noqa: E501
        :rtype: str
        """
        return self._data_type

    @data_type.setter
    def data_type(self, data_type):
        """Sets the data_type of this FormserviceapiformsrendererexternalvaluesFieldType.


        :param data_type: The data_type of this FormserviceapiformsrendererexternalvaluesFieldType.  # noqa: E501
        :type: str
        """
        allowed_values = ["string", "secureString", "integer", "decimal", "boolean", "reference", "complex", "dateTime", "file"]  # noqa: E501
        if data_type not in allowed_values:
            raise ValueError(
                "Invalid value for `data_type` ({0}), must be one of {1}"  # noqa: E501
                .format(data_type, allowed_values)
            )

        self._data_type = data_type

    @property
    def reference_type(self):
        """Gets the reference_type of this FormserviceapiformsrendererexternalvaluesFieldType.  # noqa: E501


        :return: The reference_type of this FormserviceapiformsrendererexternalvaluesFieldType.  # noqa: E501
        :rtype: str
        """
        return self._reference_type

    @reference_type.setter
    def reference_type(self, reference_type):
        """Sets the reference_type of this FormserviceapiformsrendererexternalvaluesFieldType.


        :param reference_type: The reference_type of this FormserviceapiformsrendererexternalvaluesFieldType.  # noqa: E501
        :type: str
        """

        self._reference_type = reference_type

    @property
    def fields(self):
        """Gets the fields of this FormserviceapiformsrendererexternalvaluesFieldType.  # noqa: E501


        :return: The fields of this FormserviceapiformsrendererexternalvaluesFieldType.  # noqa: E501
        :rtype: list[FormserviceapiformsrendererexternalvaluesFieldTypeFields]
        """
        return self._fields

    @fields.setter
    def fields(self, fields):
        """Sets the fields of this FormserviceapiformsrendererexternalvaluesFieldType.


        :param fields: The fields of this FormserviceapiformsrendererexternalvaluesFieldType.  # noqa: E501
        :type: list[FormserviceapiformsrendererexternalvaluesFieldTypeFields]
        """

        self._fields = fields

    @property
    def is_multiple(self):
        """Gets the is_multiple of this FormserviceapiformsrendererexternalvaluesFieldType.  # noqa: E501


        :return: The is_multiple of this FormserviceapiformsrendererexternalvaluesFieldType.  # noqa: E501
        :rtype: bool
        """
        return self._is_multiple

    @is_multiple.setter
    def is_multiple(self, is_multiple):
        """Sets the is_multiple of this FormserviceapiformsrendererexternalvaluesFieldType.


        :param is_multiple: The is_multiple of this FormserviceapiformsrendererexternalvaluesFieldType.  # noqa: E501
        :type: bool
        """

        self._is_multiple = is_multiple

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(FormserviceapiformsrendererexternalvaluesFieldType, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FormserviceapiformsrendererexternalvaluesFieldType):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
